<?php
namespace Claromentis\Core\User\Directory\Ldap;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"] ?: array()) + array("_ccaa693c4f173" . "7d3bf7611e6c25" . "e1869" => base64_decode("IGlzIGludmF" . "saWQ="), "_d155d43a39de93f8" . "58123c6b6ce31d8a" => base64_decode("cHJlZ19tYXRj" . "aA=="), "_0042b42b94e" . "dac45ee46e1c" . "7cc0e21f7" => base64_decode("d" . "X" . "R" . "j"), "_995fb4acb" . "4a30eab38e" . "744c36dc6f" . "b4a" => base64_decode("WW1kSG" . "lz"), "_ca1057ad8fada1881cc7737d51f" . "cd1af" => base64_decode("VGhlIHRpbWV6b25lIG9mZnNl" . "dCA="), "_3db2b68627d67bdfe" . "07de458cf5ea3ba" => base64_decode("c3RydG" . "91cHBl" . "cg=="), "_aaabebe7ea4d" . "cd24a8e6b36cf" . "e511422" => base64_decode("VV" . "RD"), "_47c50dfc8dc" . "45a6888602c1" . "db1a193a3" => base64_decode("IGlzIG5vdCBpbiBhIHZhbGlkIExEQVAgR2VuZXJhbGlzZWQgVGltZSBmb3JtYXQ" . "="), "_3947612f1a6969300a6d08deec8052" . "77" => base64_decode("Wg" . "=="));
use Claromentis\Core\User\Directory\Exception\InvalidDateException;
use DateTime;
use DateTimeZone;
use Exception;






class GeneralizedTimeParser
{
    
    
    
    
    
    
    
    
    private $regex = '#^(\\d{14})([,.]{1}\\d+)?(Z|z|((\\+|-){1}(\\d{2}|\\d{4})))$#';
    
    
    
    
    private $parsed = null;
    
    
    
    
    private $is_utc = false;
    
    
    
    
    
    private $timezone = null;
    public function __construct($_67a0d624aebcceb0abd5ce56a53ff06f = null)
    {
        if ($_67a0d624aebcceb0abd5ce56a53ff06f) {
            $this->initWithDate($_67a0d624aebcceb0abd5ce56a53ff06f);
        }
    }
    
    
    
    
    
    
    
    public function initWithDate($_67a0d624aebcceb0abd5ce56a53ff06f)
    {
        
        
        $this->parsed = null;
        $this->timezone = null;
        $this->is_utc = false;
        
        
        $_3edeea3a30945de8abb845ca7489c82a = [];
        $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_d155d43a39de93f858123c6b" . "6ce31d8a"]($this->regex, $_67a0d624aebcceb0abd5ce56a53ff06f, $_3edeea3a30945de8abb845ca7489c82a);
        if (empty($_3edeea3a30945de8abb845ca7489c82a)) {
            throw new InvalidDateException($_67a0d624aebcceb0abd5ce56a53ff06f . $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_47c50dfc8dc45a6888" . "602c1db1a193a3"]);
        }
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_3db2b68627d67bdfe07de458cf5ea3" . "ba"]($_3edeea3a30945de8abb845ca7489c82a[3]) === $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_3947612f1a6969300a" . "6d08deec805277"]) {
            $this->is_utc = true;
            $this->timezone = new DateTimeZone($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_0042b42b94edac45ee46e1" . "c7cc0e21f7"]);
        }
        if (!$this->is_utc && isset($_3edeea3a30945de8abb845ca7489c82a[4])) {
            try {
                $this->timezone = new DateTimeZone($_3edeea3a30945de8abb845ca7489c82a[4]);
            } catch (Exception $_fe441aa3ef350bfb1a1a1ad8520dd530) {
                throw new InvalidDateException($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_ca1057ad8f" . "ada1881cc77" . "37d51fcd1af"] . $_3edeea3a30945de8abb845ca7489c82a[4] . $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_ccaa693c4f1737d3b" . "f7611e6c25e1869"]);
            }
        }
        $this->parsed = DateTime::createFromFormat($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_995fb4acb4a3" . "0eab38e744c36" . "dc6fb4a"], $_3edeea3a30945de8abb845ca7489c82a[1], $this->timezone);
        return $this;
    }
    
    
    
    
    
    
    public function getDate() : ?DateTime
    {
        if (!$this->parsed) {
            return null;
        }
        return clone $this->parsed;
    }
    
    
    
    
    
    
    public function getUTCDate() : ?DateTime
    {
        if (!$this->parsed) {
            return null;
        }
        $_07af7964f51512e67eca70b67f086fce = clone $this->parsed;
        $_07af7964f51512e67eca70b67f086fce->setTimezone(new DateTimeZone($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_aaabebe7ea4dcd24a8e6b36cfe51142" . "2"]));
        return $_07af7964f51512e67eca70b67f086fce;
    }
    
    
    
    
    
    
    public function isUTC() : bool
    {
        return $this->is_utc;
    }
}